



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python中的zip、map、reduce 、lambda函数的使用。</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python中的zip、map、reduce 、lambda函数的使用。</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 17:12:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>lambda</strong>只是一个表达式，函数体比def简单很多。</p>
<p>lambda的主体是一个表达式，而不是一个代码块。仅仅能在lambda表达式中封装有限的逻辑进去。</p>
<p>lambda表达式是起到一个函数速写的作用。允许在代码内嵌入一个函数的定义。</p>
<p>如下例子：</p>
<p><img referrerpolicy="no-referrer"src="http://img.my.csdn.net/uploads/201303/13/1363142998_9184.jpg" /></p>
<p>定义了一个lambda表达式，求三个数的和。</p>
<p>再看一个例子：</p>
<p>用lambda表达式求n的阶乘。</p>
<p><img referrerpolicy="no-referrer"src="http://img.my.csdn.net/uploads/201303/13/1363143422_1107.jpg" /></p>
<p>------------------------------</p>
<p>lambda表达式也可以用在def函数中。</p>
<p>看例子：</p>
<p><img referrerpolicy="no-referrer"src="http://img.my.csdn.net/uploads/201303/13/1363144140_8158.jpg" /></p>
<p>这里定义了一个action函数，返回了一个lambda表达式。其中lambda表达式获取到了上层def作用域的变量名x的值。</p>
<p>a是action函数的返回值，a(22)，即是调用了action返回的lambda表达式。</p>
<p>这里也可以把def直接写成lambda形式。如下</p>
<p><img referrerpolicy="no-referrer"src="http://img.my.csdn.net/uploads/201303/13/1363144370_7869.jpg" /></p>
<p><strong>zip()函数用法</strong></p>
<p>zip()是Python的一个内建函数，它接受一系列可迭代的对象作为参数，将对象中对应的元素打包成一个个tuple（元组），然后返回由这些tuples组成的list（列表）。若传入参数的长度不等，则返回list的长度和参数中长度最短的对象相同。利用*号操作符，可以将list unzip（解压），看下面的例子就明白了：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1 2 3 4 5 6 7 8 9</pre>
</td>
<td>
<pre class="prettyprint linenums">&gt;&gt;&gt;&nbsp;a =&nbsp;[1,2,3]<br />&gt;&gt;&gt;&nbsp;b =&nbsp;[4,5,6]<br />&gt;&gt;&gt;&nbsp;c =&nbsp;[4,5,6,7,8]<br />&gt;&gt;&gt;&nbsp;zipped =&nbsp;zip(a,b)</pre>
<pre class="prettyprint linenums">[(1,&nbsp;4),&nbsp;(2,&nbsp;5),&nbsp;(3,&nbsp;6)]<br />&gt;&gt;&gt;&nbsp;zip(a,c)<br />[(1,&nbsp;4),&nbsp;(2,&nbsp;5),&nbsp;(3,&nbsp;6)]<br />&gt;&gt;&gt;&nbsp;zip(*zipped)<br />[(1,&nbsp;2,&nbsp;3),&nbsp;(4,&nbsp;5,&nbsp;6)]</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>对于这个并不是很常用函数，下面举几个例子说明它的用法：</p>
<h3>* 二维矩阵变换（矩阵的行列互换）</h3>
<p>比如我们有一个由列表描述的二维矩阵<br />a = [[1, 2, 3], [4, 5, 6], [7, 8, 9]]<br />通过python列表推导的方法，我们也能轻易完成这个任务</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1 2</pre>
</td>
<td>
<pre class="prettyprint linenums"><strong>print</strong>&nbsp;[&nbsp;[row[col]&nbsp;<strong>for</strong>&nbsp;row&nbsp;<strong>in</strong>&nbsp;a]&nbsp;<strong>for</strong>&nbsp;col&nbsp;<strong>in</strong>&nbsp;range(len(a[0]))]<br />[[1,&nbsp;4,&nbsp;7],&nbsp;[2,&nbsp;5,&nbsp;8],&nbsp;[3,&nbsp;6,&nbsp;9]]</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>另外一种让人困惑的方法就是利用zip函数：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1 2 3 4 5</pre>
</td>
<td>
<pre class="prettyprint linenums">&gt;&gt;&gt;&nbsp;a =&nbsp;[[1,&nbsp;2,&nbsp;3],&nbsp;[4,&nbsp;5,&nbsp;6],&nbsp;[7,&nbsp;8,&nbsp;9]]<br />&gt;&gt;&gt;&nbsp;zip(*a)<br />[(1,&nbsp;4,&nbsp;7),&nbsp;(2,&nbsp;5,&nbsp;8),&nbsp;(3,&nbsp;6,&nbsp;9)]<br />&gt;&gt;&gt;&nbsp;map(list,zip(*a))<br />[[1,&nbsp;4,&nbsp;7],&nbsp;[2,&nbsp;5,&nbsp;8],&nbsp;[3,&nbsp;6,&nbsp;9]]</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>这种方法速度更快但也更难以理解，将list看成tuple解压，恰好得到我们&ldquo;行列互换&rdquo;的效果，再通过对每个元素应用list()函数，将tuple转换为list</p>
<p><strong>Python函数式编程&mdash;&mdash;map()、reduce()</strong></p>
<h1>1.map()</h1>
<p>格式：<code>map( func, seq1[, seq2...] )</code></p>
<p>Python函数式编程中的<code>map()</code>函数是将func作用于seq中的每一个元素，并用一个列表给出返回值。如果func为None，作用同<code>zip()</code>。</p>
<p><strong>当seq只有一个时</strong>，将func函数作用于这个seq的每个元素上，得到一个新的seq。下图说明了只有一个seq的时候map()函数是如何工作的（本文图片来源：《Core Python Programming (2nd edition)》）。</p>
<p><img referrerpolicy="no-referrer"src="http://www.pythoner.com/wp-content/uploads/2013/01/map-1-300x162.png" /></p>
<p>可以看出，seq中的每个元素都经过了func函数的作用，得到了func(seq[n])组成的列表。</p>
<p>下面举一个例子进行说明。假设我们想要得到一个列表中数字%3的余数，那么可以写成下面的代码。</p>
<div>
<div>Python函数式编程之map使用（一个seq）</p>
<div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<p>Python</p></div>
</div>
<div>&nbsp;</div>
<div>
<table>
<tbody>
<tr>
<td>
<div>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</div>
</td>
<td>
<div>
<div># 使用map</div>
<div>print map( lambda x: x%3, range(6) )&nbsp;&nbsp;# [0, 1, 2, 0, 1, 2]</div>
<div>&nbsp;</div>
<div>#使用列表解析</div>
<div>print [x%3 for x in range(6)]&nbsp;&nbsp;# [0, 1, 2, 0, 1, 2]</div>
<div>&nbsp;</div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>这里又和上次的<code>filter()</code>一样，使用了列表解析的方法代替map执行。那么，什么时候是列表解析无法代替map的呢？</p>
<p>原来，<strong>当seq多于一个时</strong>，map可以并行地对每个seq执行如下图所示的过程：</p>
<p><img referrerpolicy="no-referrer"src="http://www.pythoner.com/wp-content/uploads/2013/01/map-2-300x191.png" /></p>
<p>也就是说每个seq的同一位置的元素在执行过一个多元的func函数之后，得到一个返回值，这些返回值放在一个结果列表中。</p>
<p>下面的例子是求两个列表对应元素的积，可以想象，这是一种可能会经常出现的状况，而如果不是用map的话，就要使用一个for循环，依次对每个位置执行该函数。</p>
<div>
<div>Python函数式编程之map使用（多个seq）</p>
<div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<p>Python</p></div>
</div>
<div>&nbsp;</div>
<div>
<table>
<tbody>
<tr>
<td>
<div>
<div>1</div>
</div>
</td>
<td>
<div>
<div>print map( lambda x, y: x * y, [1, 2, 3], [4, 5, 6] )&nbsp;&nbsp;# [4, 10, 18]</div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>上面是返回值是一个值的情况，实际上也可以是一个元组。下面的代码不止实现了乘法，也实现了加法，并把积与和放在一个元组中。</p>
<div>
<div>Python函数式编程之map使用（多个seq）</p>
<div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<p>Python</p></div>
</div>
<div>&nbsp;</div>
<div>
<table>
<tbody>
<tr>
<td>
<div>
<div>1</div>
</div>
</td>
<td>
<div>
<div>print map( lambda x, y: ( x * y, x + y), [1, 2, 3], [4, 5, 6] )&nbsp;&nbsp;# [(4, 5), (10, 7), (18, 9)]</div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>还有就是上面说的<strong>func是None</strong>的情况，它的目的是将多个列表相同位置的元素归并到一个元组，在现在已经有了专用的函数<code>zip()</code>了。</p>
<div>
<div>Python函数式编程之map使用（func为None）</p>
<div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<p>Python</p></div>
</div>
<div>&nbsp;</div>
<div>
<table>
<tbody>
<tr>
<td>
<div>
<div>1</div>
<div>2</div>
<div>3</div>
</div>
</td>
<td>
<div>
<div>print map( None, [1, 2, 3], [4, 5, 6] )&nbsp;&nbsp;# [(1, 4), (2, 5), (3, 6)]</div>
<div>&nbsp;</div>
<div>print zip( [1, 2, 3], [4, 5, 6] )&nbsp;&nbsp;# [(1, 4), (2, 5), (3, 6)]</div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><strong>需要注意的是，不同长度的多个seq是无法执行map函数的，会出现类型错误。</strong></p>
<h1>2.reduce()</h1>
<p>格式：<code>reduce( func, seq[, init] )</code></p>
<p>reduce函数即为化简，它是这样一个过程：每次迭代，将上一次的迭代结果（第一次时为init的元素，如没有init则为seq的第一个元素）与下一个元素一同执行一个二元的func函数。在reduce函数中，init是可选的，如果使用，则作为第一次迭代的第一个元素使用。</p>
<p>简单来说，可以用这样一个形象化的式子来说明：<br /><code>reduce( func, [1, 2,3] ) = func( func(1, 2), 3)</code></p>
<p>下面是reduce函数的工作过程图：</p>
<p><img referrerpolicy="no-referrer"src="http://www.pythoner.com/wp-content/uploads/2013/01/reduce-300x257.png" /></p>
<p>举个例子来说，<strong>阶乘</strong>是一个常见的数学方法，Python中并没有给出一个阶乘的内建函数，我们可以使用reduce实现一个阶乘的代码。</p>
<div>
<div>Python函数式编程之reduce使用</p>
<div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<p>Python</p></div>
</div>
<div>&nbsp;</div>
<div>
<table>
<tbody>
<tr>
<td>
<div>
<div>1</div>
<div>2</div>
</div>
</td>
<td>
<div>
<div>n = 5</div>
<div>print reduce(lambda x, y: x * y, range(1, n + 1))&nbsp;&nbsp;# 120</div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>那么，如果我们希望得到2倍阶乘的值呢？这就可以用到init这个可选参数了。</p>
<div>
<div>Python函数式编程之reduce使用</p>
<div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<p>Python</p></div>
</div>
<div>&nbsp;</div>
<div>
<table>
<tbody>
<tr>
<td>
<div>
<div>1</div>
<div>2</div>
<div>3</div>
</div>
</td>
<td>
<div>
<div>m = 2</div>
<div>n = 5</div>
<div>print reduce( lambda x, y: x * y, range( 1, n + 1 ), m )&nbsp;&nbsp;# 240</div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qndk438.html">Linux常用命令学习8---（用户和用户组管理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1l2nz8.html">2016HUAS&lowbar;ACM暑假集训3G - 还是畅通工程</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv7mr1q.html">JS中将JSON的字符串解析成JSON数据格式《转》</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydwx32q.html">修改ECSHOP系统红包序列号规律</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mnjrkq.html">return&comma;exit&comma;die</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdek4ex9.html">Cocos2d-x&mdash;&mdash;CocosBuilder官方帮助文档翻译2 多分辨率支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e13wmk9.html">Entity Framework 6&period;1 学习系列1--概况、安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04g34q.html">Monkeyrunner入门示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmo1y09.html">javascript笔记6之函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjy2xk8.html">&lbrack;大数据&rsqb;-Elasticsearch5&period;3&period;1&plus;Kibana5&period;3&period;1从单机到分布式的安装与使用&amp;lt&semi;2&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z24209.html">关于HTTP，你知道哪些？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me6prrq.html">CodeBlocks使用介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgpjve8.html">&lbrack;USACO 08JAN&rsqb;Haybale Guessing</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m3oe48.html">AspNetCoreapi 使用 Docker &plus; Centos 7部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1ml0g9.html">修正Percona Monitoring Plugins for Zabbix的一处脚本Bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1el149.html">jackson使用问题&colon;mapper&period;readValue&lpar;&rpar;将JSON字符串转反序列化为对象失败或异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1deo5q.html">06 Zabbix4&period;0系统CISCO交换机告警模板规划信息&lpar;基础&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5ywg4q.html">ajax方式下载文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv23e3o9.html">XGBoost参数调优小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4koek9.html">微软VBS生成Excel内容和图表示例</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qll2n5xq.html">Hive记录-配置支持事务管理hive-site&period;xml</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rnjk08.html">CodeForces - 615D Multipliers（数论）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e47j4k9.html">Mybatis 学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25n27wq.html">IPv4套接字地址结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw3k4x9.html">android ContentObserver内容观察者基本使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2oj119.html">QWidget窗口类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e473wz9.html">Java SE之向上转型与向下转型</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw3r079.html">&lbrack;POI2007&rsqb;ZAP-Queries （莫比乌斯反演&plus;整除分块）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyl012q.html">&lbrack;转&rsqb;Linux&sol;Windows下脚本对拍程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wl67rq.html">SQL Server 备份还原</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
